#include <WinUser32.mqh>
#property copyright "Copyright  2005, timotei"
#property link      "no link"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 MediumSlateBlue
#property indicator_color2 SandyBrown
//=====================================================================================================
extern int       BoxSize=5;
extern int       Reverse=2;
extern int       BarsCount=50;
extern int       XOSymbol=158;
//=====================================================================================================
double X[];
double O[];

//=====================================================================================================
datetime prevtime=0;

double Step=0.0;
double Cur=0.0;
double RndCur=0.0;
double LastBox=0.0;
double XBegin=0.0;
double OBegin=0.0;

int LastBoxNo=0;
int BoxCurNo=0;
int BarCnt=0;

bool XO=false;
bool startflag=true;
//=====================================================================================================
int init()
{
   IndicatorBuffers(2);

   if(
   !SetIndexBuffer(0,X) &&
   !SetIndexBuffer(1,O))
   Print("cannot set indicator buffers!");

   SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,2);

   SetIndexLabel(0,"X");
   SetIndexLabel(1,"O");

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   
  	Step = (BoxSize)*Point;
	LastBoxNo=MathFloor(Close[0]/Step);
	LastBox	= LastBoxNo*Step;
   prevtime = Time[0];
  	
	if (Bars<BarsCount) BarCnt=Bars; else BarCnt=BarsCount;
   return(0);
}
//=====================================================================================================
int deinit()
{	return(0);	}
//=====================================================================================================
void ShiftR()                             //    
{   
   int i=0;
   int n;
   while(i!=BarCnt)
	{
      n=i+1;
		X[i]=X[n];		O[i]=O[n];
      i++;
	}
}
//=====================================================================================================
void ShiftL()                             //     
{   
   int i=BarCnt;
   int n;
   while(i!=0)
	{
      n=i-1;
		X[i]=X[n];		O[i]=O[n];
	   i--;
	}
	X[0]=0;		O[0]=0;
}
//=====================================================================================================
bool NewBar()                             //    
{   
	if(prevtime != Time[0]) 
	{          
      prevtime = Time[0];							//  
      return(true);
   }
}
//=====================================================================================================
double GetCurPrice()
{
	return(Close[0]);
}
//=====================================================================================================
void SwitchXO()
{
   ShiftL();
	XO=!XO;
}
//=====================================================================================================
void AddX(bool Rev)
{
  	LastBoxNo++;
	LastBox=(LastBoxNo*Step);
	if (Rev)	{SwitchXO();XBegin=LastBox;}
	
	X[0]=RndCur;O[0]=XBegin;
  	LastBoxNo=BoxCurNo;
}
//=====================================================================================================
void AddO(bool Rev)
{
  	LastBoxNo--;
	LastBox=(LastBoxNo*Step);
	if (Rev)	{SwitchXO();OBegin=LastBox;}
	
	X[0]=RndCur;O[0]=OBegin;
  	LastBoxNo=BoxCurNo;
}
//=====================================================================================================
void CheckBox()
{
	if (!XO)// OOOOOOOOOOOOO
	{
		if       (BoxCurNo-LastBoxNo >= Reverse)	AddX(true);
		else if  (BoxCurNo<LastBoxNo)	      	   AddO(false);
	}
	else
	if (XO) // XXXXXXXXXXXXX
	{
		if        (LastBoxNo-BoxCurNo >= Reverse)	AddO(true);
		else if   (BoxCurNo>LastBoxNo)   			AddX(false);
	}
}
//=====================================================================================================
int start()
{
   if (startflag) {O[0]=LastBox;startflag=false;}
   if(NewBar())   ShiftR();										//       
	Cur=GetCurPrice();
	RndCur	= MathFloor(Cur/Step)*Step;
	BoxCurNo	= MathFloor(Cur/Step);
	LastBox	= LastBoxNo*Step;
	CheckBox();  
	return(0);
}
//=====================================================================================================


